/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef NMM_IURL_HPP
#define NMM_IURL_HPP

#include "nmm/nmm_prefix.hpp"

#include "nmm/comm/Interface.hpp"
#include "nmm/comm/messaging/Event.hpp"
#include "nmm/comm/messaging/IllegalStateException.hpp"
#include <memory>


#include "visibility.hpp"

namespace NMM
{

  class DLLEXPORT IURL : virtual public NMM::Interface { 
  public:
    IURL() : NMM::Interface(IURL::IURL_type, "NMM") { };

    IURL(NMM::NMMObject& parent) : NMM::Interface (parent, IURL::IURL_type, "NMM") { };

    virtual ~IURL() {};

    static const char* IURL_type;

    virtual  string getInterfaceType() const { return IURL_type; }

    NMM::Interface* copy() const { return new IURL(*this); }
    static void used(); 
    static const char* setURL_event;
    static const char* getURL_event;

    virtual void setURL(const string& url)
      throw(const NMM::SerializedException&);

    virtual string getURL() const
      throw(const NMM::SerializedException&);


  };

  typedef auto_ptr<IURL> IURL_var;




}

#include "nmm/nmm_suffix.hpp"

#endif
